#include <iostream>
#include <iomanip>
#include <set>
#include <vector>

#include "consts.h"
#include "hea.h"
#include "hyperEA3_common.h"

using namespace std;




void test_hea_recursive(vector<pair<int, int> >::const_iterator it_current_pair, const vector<pair<int, int> > &tested_pairs, const set<int> (&setCandidates)[1 << MAX], const int n, const set<int> *(&op)[MAX][MAX], const int complement[MAX]) {


	if (it_current_pair == tested_pairs.end()) {
		if (!hea::is_associative(n, op))	{
			hea::disp_op(cout, n, op);
			cout << "-not M-" << endl;
		}
	}
	else {
		int old_idx = op[it_current_pair->first][it_current_pair->second] - &setCandidates[0];

		for (int i = 0 ; i < 2; i++) {
			// 0 - not include
			// 1 - include

			if (i == 1) {
				op[it_current_pair->first][it_current_pair->second] = &setCandidates[old_idx + 1];

				if (it_current_pair->first != it_current_pair->second)
					op[it_current_pair->second][it_current_pair->first] = &setCandidates[old_idx + 1];
			}
			vector<pair<int, int> >::const_iterator it_new = it_current_pair;
			it_new++;
			
			test_hea_recursive(it_new, tested_pairs, setCandidates, n, op, complement);
			
			// clean up
			if (i == 1) {
				op[it_current_pair->first][it_current_pair->second] = &setCandidates[old_idx];

				if (it_current_pair->first != it_current_pair->second)
					op[it_current_pair->second][it_current_pair->first] = &setCandidates[old_idx];
			}
		}
	}
}




/*
0  a  b  c  d  1  
1  a  d  c  b  0  
{0}, {a}, {b}, {0, b, c}, {d}, {a, b, 1}, 
{a}, {a, b, 1}, {}, {}, {}, {}, 
{b}, {}, {a, b}, {a, b}, {a, b, 1}, {}, 
{0, b, c}, {}, {a, b}, {c, 1}, {}, {}, 
{d}, {}, {a, b, 1}, {}, {}, {}, 
{a, b, 1}, {}, {}, {}, {}, {},
*/

int main() {
	const int n = 6;
	/* element constants */
	const int undefined = 0;
	const int el_0 = 1;
	const int el_a = 1 << 1;
	const int el_b = 1 << 2;
	const int el_c = 1 << 3;
	const int el_d = 1 << 4;
	const int el_1 = 1 << 5;

	set<int> setCandidates[1 << MAX];
	// init
	for (int i = 0; i < 1 << n ; i++) {
		setCandidates[i] = set<int>();
		hea::init_set_i(setCandidates[i], i);
	}

	int orig_compl[MAX] = {5, 1, 4, 3, 2, 0};
	const set<int> *orig_plus[MAX][MAX] = {
		{&setCandidates[el_0], &setCandidates[el_a],  &setCandidates[el_b],  &setCandidates[el_b | el_c], &setCandidates[el_d], &setCandidates[el_a | el_b | el_1]}, 
		{&setCandidates[el_a], &setCandidates[el_a | el_b | el_1],  &setCandidates[undefined],  &setCandidates[undefined], &setCandidates[undefined], &setCandidates[undefined]}, 
		{&setCandidates[el_b], &setCandidates[undefined],  &setCandidates[el_a | el_b],  &setCandidates[el_a | el_b], &setCandidates[el_a | el_b | el_1], &setCandidates[undefined]}, 
		{&setCandidates[el_b | el_c], &setCandidates[undefined],  &setCandidates[el_a | el_b],  &setCandidates[el_c | el_1], &setCandidates[undefined], &setCandidates[undefined]}, 
		{&setCandidates[el_d], &setCandidates[undefined],  &setCandidates[el_a | el_b | el_1],  &setCandidates[undefined], &setCandidates[undefined], &setCandidates[undefined]}, 
		{&setCandidates[el_a | el_b | el_1], &setCandidates[undefined],  &setCandidates[undefined],  &setCandidates[undefined], &setCandidates[undefined], &setCandidates[undefined]}, 
	};

	hea::Hea testHea(n, orig_plus, orig_compl);
	disp_hea(cout, testHea);

	/* TODO: Test whether adding a zero to any existing outcome of plus operation preserves associativity

	... */

	vector<pair<int, int> > tested_pairs;
/*
	tested_pairs.push_back(pair<int, int>(0, 1));
	tested_pairs.push_back(pair<int, int>(0, 2));
	tested_pairs.push_back(pair<int, int>(0, 3));
	tested_pairs.push_back(pair<int, int>(0, 4));
	tested_pairs.push_back(pair<int, int>(0, 5));
*/
	tested_pairs.push_back(pair<int, int>(1, 1));
	tested_pairs.push_back(pair<int, int>(2, 2));
/*
	tested_pairs.push_back(pair<int, int>(2, 3));
*/
	tested_pairs.push_back(pair<int, int>(2, 4));
/*
	tested_pairs.push_back(pair<int, int>(3, 3));
*/
	

	int tested_compl[MAX] = {5, 1, 4, 3, 2, 0};
	const set<int> *tested_plus[MAX][MAX] = {
		{&setCandidates[el_0], &setCandidates[el_a],  &setCandidates[el_b],  &setCandidates[el_b | el_c], &setCandidates[el_d], &setCandidates[el_a | el_b | el_1]}, 
		{&setCandidates[el_a], &setCandidates[el_a | el_b | el_1],  &setCandidates[undefined],  &setCandidates[undefined], &setCandidates[undefined], &setCandidates[undefined]}, 
		{&setCandidates[el_b], &setCandidates[undefined],  &setCandidates[el_a | el_b],  &setCandidates[el_a | el_b], &setCandidates[el_a | el_b | el_1], &setCandidates[undefined]}, 
		{&setCandidates[el_b | el_c], &setCandidates[undefined],  &setCandidates[el_a | el_b],  &setCandidates[el_c | el_1], &setCandidates[undefined], &setCandidates[undefined]}, 
		{&setCandidates[el_d], &setCandidates[undefined],  &setCandidates[el_a | el_b | el_1],  &setCandidates[undefined], &setCandidates[undefined], &setCandidates[undefined]}, 
		{&setCandidates[el_a | el_b | el_1], &setCandidates[undefined],  &setCandidates[undefined],  &setCandidates[undefined], &setCandidates[undefined], &setCandidates[undefined]}, 
	};

	test_hea_recursive(tested_pairs.begin(), tested_pairs, setCandidates, n, tested_plus, tested_compl);

	

	if (hea::is_associative(n, orig_plus))
		cout << "Associative" << endl;
	else
		cout << "Not associative" << endl;
	
}
